import React, { useMemo, useState } from 'react';
import { Col, Container, Row, Table } from 'react-bootstrap';
import { RBTMenuBar } from '../menubar';
import { RBTRowControls } from '../rowcontrols';
import { CompareRBTRow } from '../common';
import { RBTableHead } from '../tableHead';
import { RBTablePlaceholder } from '../tablePlaceholder';
import { RBTableBody } from '../tableBody/tableBody.components';
export var RBTable = function (_a) {
    var _b, _c, _d;
    var columns = _a.columns, data = _a.data, name = _a.name, varient = _a.varient, header = _a.header, footer = _a.footer;
    //
    var initialisedRows = useMemo(function () {
        var results = [];
        //
        if (data) {
            for (var index = 0; index < data.length; index++) {
                var row = {
                    data: data[index],
                    position: index,
                    filters: [],
                };
                results.push(row);
            }
        }
        // Ensure all the results are correctly sorted
        return results.sort(CompareRBTRow);
    }, [data]);
    var showTableHead = useMemo(function () { var _a; return (_a = header === null || header === void 0 ? void 0 : header.enableTableHead) !== null && _a !== void 0 ? _a : true; }, [header]);
    // We want to wrap eac data item within a row object which controls how informaiton is displayed
    // by default nothing should be filtered from view and everything should be displayed.
    var _e = useState(initialisedRows), rows = _e[0], setRows = _e[1];
    var columnDefs = useState(columns !== null && columns !== void 0 ? columns : [])[0];
    var _f = useState(false), compact = _f[0], setCompact = _f[1];
    var styleVarient = useMemo(function () { return varient !== null && varient !== void 0 ? varient : 'dark'; }, [varient]);
    var tableName = useMemo(function () {
        var result = 'Table';
        if (name && name.length > 0) {
            result = name + ' Table';
        }
        return result;
    }, [name]);
    return (React.createElement(Container, { fluid: true },
        React.createElement(RBTMenuBar, { enableDensityToggle: (_b = header === null || header === void 0 ? void 0 : header.enableDensityToggle) !== null && _b !== void 0 ? _b : showTableHead, enableExportButton: (_c = header === null || header === void 0 ? void 0 : header.enableExportButton) !== null && _c !== void 0 ? _c : showTableHead, isCompact: compact, setCompact: setCompact, name: name, varient: styleVarient, columns: columnDefs, data: rows, handleDisplayedRows: setRows }),
        React.createElement(Row, null,
            React.createElement(Col, null,
                React.createElement(Table, { hover: true, responsive: true, size: compact ? 'sm' : '', "aria-label": tableName },
                    React.createElement(RBTableHead, { columns: columnDefs, enableTableHead: showTableHead, name: name, varient: styleVarient }),
                    rows.length > 0 ? (React.createElement(RBTableBody, { columns: columnDefs, name: name, varient: styleVarient, data: rows })) : (React.createElement(RBTablePlaceholder, { columns: columnDefs, name: name, varient: styleVarient }))))),
        ((_d = footer === null || footer === void 0 ? void 0 : footer.enablePagination) !== null && _d !== void 0 ? _d : true) ? (React.createElement(RBTRowControls, { columns: columnDefs, data: rows, handleDisplayedRows: setRows, name: name, varient: styleVarient })) : null));
};
//# sourceMappingURL=table.components.js.map