import React, { useMemo } from 'react';
import { CompareRBTRow } from '../common';
export var RBTableBody = function (_a) {
    var columns = _a.columns, data = _a.data, name = _a.name;
    var columnPrefix = useMemo(function () { return (name && name.length > 0 ? name + '.table.body' : 'table.body'); }, [name]);
    var displayed = useMemo(function () {
        var results = data.filter(function (record) { return record.filters.length === 0; });
        return results.sort(CompareRBTRow);
    }, [data]);
    /**
     * This will process the Cell atribute (if set)
     * @param column
     * @param row
     * @returns
     */
    var GenerateCell = function (index, column, row) {
        var id = columnPrefix;
        if (column.id && column.id.length > 0) {
            id = column.id;
        }
        var result;
        if (typeof column.Cell === 'function') {
            result = (React.createElement("td", { key: id + '.' + row.position + '.' + index }, column.Cell({ column: id, originalRow: row.data })));
        }
        // If there was no Id or Cell then result should be undefined
        if (!result && typeof column.accessorFn === 'function') {
            var keyOrValue = column.accessorFn(row.data);
            if (keyOrValue in row.data) {
                var data_1 = row.data[keyOrValue];
                if (typeof data_1 === 'string' || typeof data_1 === 'number') {
                    result = React.createElement("td", { key: id + '.' + row.position + '.' + index }, data_1);
                }
            }
            else if (typeof keyOrValue === 'string' || typeof keyOrValue === 'number') {
                result = React.createElement("td", { key: id + '.' + row.position + '.' + index }, keyOrValue);
            }
            else {
                console.log('GenerateAccessorFN - Unable to convert data into table AccessorFN: ' + JSON.stringify(keyOrValue));
            }
        }
        // If there was no Id or AccessorFN then result should be undefined
        if (!result && column.accessorKey) {
            var data_2 = row.data[column.accessorKey];
            if (typeof data_2 === 'string' || typeof data_2 === 'number') {
                result = React.createElement("td", { key: id + '.' + row.position + '.' + index }, data_2);
            }
            else {
                console.log('GenerateAccessorFN - Unable to convert data into table AccessorFN: ' + JSON.stringify(data_2));
            }
        }
        return result;
    };
    return (React.createElement("tbody", null, displayed.map(function (row) {
        return (React.createElement("tr", { key: row.position }, columns.map(function (column, index) {
            return GenerateCell(index, column, row);
        })));
    })));
};
//# sourceMappingURL=tableBody.components.js.map